> This page is for API Reference.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.navipartner.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.navipartner.com/_mcp/server.

# Add payment method

POST https://api.npretail.app/{tenant}/{environment}/{company}/membership/{membershipId}/paymentmethods
Content-Type: application/json

Add a new payment method for a membership.

Reference: https://docs.navipartner.com/apis/api-reference/memberships/service-paymentmethod/add-payment-method

## Authentication

- `x-np-api-key` header (required) — API Key authentication via header

## Request

### Path parameters

- `tenant` (string, required) — Your Entra Tenant ID. [More details.](/paths#1-tenant)
- `environment` (string, required) — Your Business Central Environment. [More details.](/paths#2-environment)
- `company` (string, required) — Your Business Central Company. [More details.](/paths#3-company)
- `membershipId` (UUID, required) — Unique identifier for a membership.

### Body (application/json)

This endpoint expects an AddPaymentMethodRequest.

- `paymentMethod` (PaymentMethodCreateRequestDTO, required) — The PaymentMethodCreateRequestDTO extends the PaymentMethodDTO and includes additional properties such as the paymentToken and shopperReference. This DTO is used when creating a new payment method.

## Response

### 200

- `paymentMethod` (PaymentMethodCreateResponseDTO, required) — The PaymentMethodCreateResponseDTO extends the PaymentMethodCreateRequestDTO and includes additional property - the payment method ID. This DTO is used when returning results for the payment method create request.

## Types

### PaymentMethodCreateRequestDTO

The PaymentMethodCreateRequestDTO extends the PaymentMethodDTO and includes additional properties such as the paymentToken and shopperReference. This DTO is used when creating a new payment method.

- `PANLastDigits` (string, optional) — The last 4 digits of the payment card number.
- `PSP` (enum, optional) — The payment service provider of the payment method.
  - Allowed values: `Adyen`, `Vipps`
- `alias` (string, optional) — A short description that can be assigned to each payment method by the end user.
- `default` (boolean, optional) — Indicates whether the payment method should be set up as default.
- `expiryDate` (date, optional) — The expiry date of the card.
- `maskedPAN` (string, optional) — The masked PAN of the card. The exact structure depends on the PSP.
- `paymentBrand` (string, optional) — The payment method brand.
- `paymentInstrument` (string, optional) — The payment method type.
- `paymentToken` (string, optional) — The shopper reference of the payment method.
- `shopperReference` (string, optional) — The shopper reference of the payment method.
- `status` (enum, optional) — The status of the payment method.
  - Allowed values: `Active`, `Archived`

### PaymentMethodCreateResponseDTO

The PaymentMethodCreateResponseDTO extends the PaymentMethodCreateRequestDTO and includes additional property - the payment method ID. This DTO is used when returning results for the payment method create request.

- `id` (UUID, required) — Unique identifier for a payment method.
- `PANLastDigits` (string, optional) — The last 4 digits of the payment card number.
- `PSP` (enum, optional) — The payment service provider of the payment method.
  - Allowed values: `Adyen`, `Vipps`
- `alias` (string, optional) — A short description that can be assigned to each payment method by the end user.
- `default` (boolean, optional) — Indicates whether the payment method should be set up as default.
- `expiryDate` (date, optional) — The expiry date of the card.
- `maskedPAN` (string, optional) — The masked PAN of the card. The exact structure depends on the PSP.
- `paymentBrand` (string, optional) — The payment method brand.
- `paymentInstrument` (string, optional) — The payment method type.
- `paymentToken` (string, optional) — The shopper reference of the payment method.
- `shopperReference` (string, optional) — The shopper reference of the payment method.
- `status` (enum, optional) — The status of the payment method.
  - Allowed values: `Active`, `Archived`

## Examples

**Request**

```json
{
  "paymentMethod": {
    "PANLastDigits": "1234",
    "PSP": "Adyen",
    "alias": "",
    "default": false,
    "expiryDate": "2029-09-30",
    "maskedPAN": "541333 **** 1234",
    "paymentBrand": "visa",
    "paymentInstrument": "Card",
    "paymentToken": "FMF7KDR3WL9S2DK5",
    "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
    "status": "Active"
  }
}
```

**Response**

```json
{
  "paymentMethod": {
    "id": "a7b41af8-d187-48d9-89e0-a57c47039004",
    "PANLastDigits": "1234",
    "PSP": "Adyen",
    "alias": "",
    "default": false,
    "expiryDate": "2029-09-30",
    "maskedPAN": "541333 **** 1234",
    "paymentBrand": "visa",
    "paymentInstrument": "Card",
    "paymentToken": "FMF7KDR3WL9S2DK5",
    "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
    "status": "Active"
  }
}
```

**SDK Code**

```python ExamplePaymentMethod
import requests

url = "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods"

payload = { "paymentMethod": {
        "PANLastDigits": "1234",
        "PSP": "Adyen",
        "alias": "",
        "default": False,
        "expiryDate": "2029-09-30",
        "maskedPAN": "541333 **** 1234",
        "paymentBrand": "visa",
        "paymentInstrument": "Card",
        "paymentToken": "FMF7KDR3WL9S2DK5",
        "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
        "status": "Active"
    } }
headers = {
    "x-np-api-key": "<NaviPartner API Key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript ExamplePaymentMethod
const url = 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods';
const options = {
  method: 'POST',
  headers: {'x-np-api-key': '<NaviPartner API Key>', 'Content-Type': 'application/json'},
  body: '{"paymentMethod":{"PANLastDigits":"1234","PSP":"Adyen","alias":"","default":false,"expiryDate":"2029-09-30","maskedPAN":"541333 **** 1234","paymentBrand":"visa","paymentInstrument":"Card","paymentToken":"FMF7KDR3WL9S2DK5","shopperReference":"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895","status":"Active"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go ExamplePaymentMethod
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods"

	payload := strings.NewReader("{\n  \"paymentMethod\": {\n    \"PANLastDigits\": \"1234\",\n    \"PSP\": \"Adyen\",\n    \"alias\": \"\",\n    \"default\": false,\n    \"expiryDate\": \"2029-09-30\",\n    \"maskedPAN\": \"541333 **** 1234\",\n    \"paymentBrand\": \"visa\",\n    \"paymentInstrument\": \"Card\",\n    \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n    \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n    \"status\": \"Active\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-np-api-key", "<NaviPartner API Key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby ExamplePaymentMethod
require 'uri'
require 'net/http'

url = URI("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-np-api-key"] = '<NaviPartner API Key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"paymentMethod\": {\n    \"PANLastDigits\": \"1234\",\n    \"PSP\": \"Adyen\",\n    \"alias\": \"\",\n    \"default\": false,\n    \"expiryDate\": \"2029-09-30\",\n    \"maskedPAN\": \"541333 **** 1234\",\n    \"paymentBrand\": \"visa\",\n    \"paymentInstrument\": \"Card\",\n    \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n    \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n    \"status\": \"Active\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java ExamplePaymentMethod
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods")
  .header("x-np-api-key", "<NaviPartner API Key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"paymentMethod\": {\n    \"PANLastDigits\": \"1234\",\n    \"PSP\": \"Adyen\",\n    \"alias\": \"\",\n    \"default\": false,\n    \"expiryDate\": \"2029-09-30\",\n    \"maskedPAN\": \"541333 **** 1234\",\n    \"paymentBrand\": \"visa\",\n    \"paymentInstrument\": \"Card\",\n    \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n    \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n    \"status\": \"Active\"\n  }\n}")
  .asString();
```

```php ExamplePaymentMethod
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods', [
  'body' => '{
  "paymentMethod": {
    "PANLastDigits": "1234",
    "PSP": "Adyen",
    "alias": "",
    "default": false,
    "expiryDate": "2029-09-30",
    "maskedPAN": "541333 **** 1234",
    "paymentBrand": "visa",
    "paymentInstrument": "Card",
    "paymentToken": "FMF7KDR3WL9S2DK5",
    "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
    "status": "Active"
  }
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-np-api-key' => '<NaviPartner API Key>',
  ],
]);

echo $response->getBody();
```

```csharp ExamplePaymentMethod
using RestSharp;

var client = new RestClient("https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods");
var request = new RestRequest(Method.POST);
request.AddHeader("x-np-api-key", "<NaviPartner API Key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"paymentMethod\": {\n    \"PANLastDigits\": \"1234\",\n    \"PSP\": \"Adyen\",\n    \"alias\": \"\",\n    \"default\": false,\n    \"expiryDate\": \"2029-09-30\",\n    \"maskedPAN\": \"541333 **** 1234\",\n    \"paymentBrand\": \"visa\",\n    \"paymentInstrument\": \"Card\",\n    \"paymentToken\": \"FMF7KDR3WL9S2DK5\",\n    \"shopperReference\": \"3AE8115C-D7A4-B9FC-4FCA-B09BFD311895\",\n    \"status\": \"Active\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift ExamplePaymentMethod
import Foundation

let headers = [
  "x-np-api-key": "<NaviPartner API Key>",
  "Content-Type": "application/json"
]
let parameters = ["paymentMethod": [
    "PANLastDigits": "1234",
    "PSP": "Adyen",
    "alias": "",
    "default": false,
    "expiryDate": "2029-09-30",
    "maskedPAN": "541333 **** 1234",
    "paymentBrand": "visa",
    "paymentInstrument": "Card",
    "paymentToken": "FMF7KDR3WL9S2DK5",
    "shopperReference": "3AE8115C-D7A4-B9FC-4FCA-B09BFD311895",
    "status": "Active"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.npretail.app/01234567-89ab-cdef-0123-456789abcdef/production/CRONUS%2520International%2520Ltd./membership/cdef7890-abcd-0123-1234-567890abcdef/paymentmethods")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```